package com.gxwebsoft.apps.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.apps.service.LinkService;
import com.gxwebsoft.apps.entity.Link;
import com.gxwebsoft.apps.param.LinkParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 常用链接推荐记录表控制器
 *
 * @author 科技小王子
 * @since 2022-11-25 12:55:33
 */
@Api(tags = "常用链接推荐记录表管理")
@RestController
@RequestMapping("/api/apps/link")
public class LinkController extends BaseController {
    @Resource
    private LinkService linkService;

    @PreAuthorize("hasAuthority('apps:link:list')")
    @OperationLog
    @ApiOperation("分页查询常用链接推荐记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<Link>> page(LinkParam param) {
        PageParam<Link, LinkParam> page = new PageParam<>(param);
        page.setDefaultOrder("sort_number asc, create_time desc");
        return success(linkService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(linkService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('apps:link:list')")
    @OperationLog
    @ApiOperation("查询全部常用链接推荐记录表")
    @GetMapping()
    public ApiResult<List<Link>> list(LinkParam param) {
        PageParam<Link, LinkParam> page = new PageParam<>(param);
        page.setDefaultOrder("sort_number asc, create_time desc");
        return success(linkService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(linkService.listRel(param));
    }

    @PreAuthorize("hasAuthority('apps:link:list')")
    @OperationLog
    @ApiOperation("根据id查询常用链接推荐记录表")
    @GetMapping("/{id}")
    public ApiResult<Link> get(@PathVariable("id") Integer id) {
        return success(linkService.getById(id));
        // 使用关联查询
        //return success(linkService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('apps:link:save')")
    @OperationLog
    @ApiOperation("添加常用链接推荐记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Link link) {
        // 记录当前登录用户id、租户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          link.setUserId(loginUser.getUserId());
          link.setMerchantCode(getMerchantCode());
        }
        if (linkService.save(link)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:link:update')")
    @OperationLog
    @ApiOperation("修改常用链接推荐记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Link link) {
        if (linkService.updateById(link)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:link:remove')")
    @OperationLog
    @ApiOperation("删除常用链接推荐记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (linkService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('apps:link:save')")
    @OperationLog
    @ApiOperation("批量添加常用链接推荐记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Link> list) {
        if (linkService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:link:update')")
    @OperationLog
    @ApiOperation("批量修改常用链接推荐记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Link> batchParam) {
        if (batchParam.update(linkService, "link_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:link:remove')")
    @OperationLog
    @ApiOperation("批量删除常用链接推荐记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (linkService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
